# LockWatch

A competitive stopwatch, created for but not limited to lock-picking
competitions.

## Build

The whole `LockWatch` application stack consists out of two parts. The
central server application, and a SPA (single page application) client
application which is compiled to WASM and served by the server.

### Client

To build the client (the `client` crate) [trunk](https://trunkrs.dev/)
is used.

```sh
trunk --config client/Trunk.toml build
```

### Server

After the client is built, the lockwatch server can be built with
following command.

```sh
cargo build --bin logwatch
```

## Usage

The logwatch server can be used with the following command line
arguments.

```
USAGE:
    lockwatch [OPTIONS]

OPTIONS:
    -a, --address <ADDRESS>          The address to listen on [default: ::1]
    -h, --help                       Print help information
    -p, --port <PORT>                The port to listen on [default: 3000]
    -s, --static-dir <STATIC_DIR>    Path to the directory containing the statically served files
                                     [default: dist]
    -v                               Set the log level. Multiple -v options increase the verbosity
    -V, --version                    Print version information
```
